#!/usr/bin/perl

$host=shift;
$community=shift;
$drive=shift;

$blocksize=&getblocksize();
$msize=int(($blocksize * &getstoragesize) / 1024 / 1024);
$mused=int(($blocksize * &getusedsize) / 1024 / 1024);

print "$msize\n";
print "$mused\n";
print &getdiskdescr(), "\n";
print "\n";


sub getblocksize {
    $blocksize=`snmpwalk $host $community hrStorageAllocationUnits.$drive 2>/dev/null`;
#    ($name,$blocks)=split(/ = /, chomp($blocksize));
    $blocks=&splitnamevalue($blocksize);
    $blocks=~s/\ .*//;
    return $blocks;
}

sub getstoragesize {
    $storagesize=`snmpwalk $host $community hrStorageSize.$drive 2>/dev/null`;
    $size=&splitnamevalue($storagesize);
    return $size;    
}

sub getusedsize {
    $usedsize=`snmpwalk $host $community hrStorageUsed.$drive 2>/dev/null`;
    $size=&splitnamevalue($usedsize);
    return $size;    
}

sub getdiskdescr {
    $diskdescr=`snmpwalk $host $community hrStorageDescr.$drive 2>/dev/null`;
    $descr=&splitnamevalue($diskdescr);
    return $descr;    
}

sub splitnamevalue {
    $namevalue=shift;
#    print $namevalue;
    chomp($namevalue);
    ($name,$value)=split(/ = /, $namevalue);
    return $value;
}
